// HelloWorldBHO.cpp : CHelloWorldBHO ̎

#include "stdafx.h"
#include "HelloWorldBHO.h"

STDMETHODIMP CHelloWorldBHO::SetSite(IUnknown* pUnkSite)
{
    if (pUnkSite != NULL)
    {
        // IWebBrowser2 ւ̃|C^LbV܂B
        HRESULT hr = pUnkSite->QueryInterface(IID_IWebBrowser2, (void **)&m_spWebBrowser);
        if (SUCCEEDED(hr))
        {
            // DWebBrowserEvents2 ̃CxgVNɓo^܂B
            hr = DispEventAdvise(m_spWebBrowser);
            if (SUCCEEDED(hr))
            {
                m_fAdvised = TRUE;
            }
        }
    }
    else
    {
        // Cxg VN̓o^𖕏܂B
        if (m_fAdvised)
        {
            DispEventUnadvise(m_spWebBrowser);
            m_fAdvised = FALSE;
        }
        // ŁALbV|C^Ȃǂ̃\[X܂B
        m_spWebBrowser.Release();
    }
    // {NX̎Ăяo܂B
    return IObjectWithSiteImpl<CHelloWorldBHO>::SetSite(pUnkSite);
}

void STDMETHODCALLTYPE CHelloWorldBHO::OnDocumentComplete(IDispatch *pDisp, VARIANT *pvarURL)
{
    HRESULT hr = S_OK;
    // IWebBrowser2 C^[tFCXɏƉ܂B
    CComQIPtr<IWebBrowser2> spTempWebBrowser = pDisp;
    // ŏʃx̃uEUɊ֘AtꂽCxgǂB
    if (spTempWebBrowser && m_spWebBrowser &&
        m_spWebBrowser.IsEqualObject(spTempWebBrowser))
    {
        // uEU猻݂ document IuWFNg擾܂...
        CComPtr<IDispatch> spDispDoc;
        hr = m_spWebBrowser->get_Document(&spDispDoc);
        if (SUCCEEDED(hr))
        {
            // ...HTML hLgɏƉ܂B
            CComQIPtr<IHTMLDocument2> spHTMLDoc = spDispDoc;
            if (spHTMLDoc != NULL)
            {
                // ŌɁA摜폜܂B
                RemoveImages(spHTMLDoc);
            }
        }
    }
}

void CHelloWorldBHO::RemoveImages(IHTMLDocument2* pDocument)
{
    CComPtr<IHTMLElementCollection> spLink;
    HRESULT hr = pDocument->get_links(&spLink);
    if (hr == S_OK && spLink != NULL)
    {
        long cImages = 0;
        hr = spLink->get_length(&cImages);
        if (hr == S_OK && cImages > 0)
        {
            for (int i = 0; i < cImages; i++)
            {
                CComVariant svarItemIndex(i);
                CComVariant svarEmpty;
                CComPtr<IDispatch> spdispImage;
                hr = spLink->item(svarItemIndex, svarEmpty, &spdispImage);
				IHTMLAnchorElement *pAnchorElement;
				spdispImage->QueryInterface(IID_PPV_ARGS(&pAnchorElement));
				BSTR bstrHref;
				BSTR bstrBefore;
				bstrHref = SysAllocString(L"http://www.microsoft.com/ja-jp/windows/products/winfamily/ie/function/default.aspx");
				pAnchorElement->get_href(&bstrBefore);
				char * psz;
				int size = ::WideCharToMultiByte(CP_ACP, 0, bstrBefore, -1, NULL, 0, NULL, NULL) - 1;
				psz = new char[size + 1];
				::WideCharToMultiByte(CP_ACP, 0, bstrBefore, -1, psz, size + 1, NULL, NULL);
//				char* psz = _com_util::ConvertBSTRToString(bstrHref);
				std::string s(psz);
				if((s.rfind("http://www.google.co.jp/chrome", s.length()-1) != std::string::npos)
					|| (s.rfind("chrome", s.length()-1) != std::string::npos)
					){
					pAnchorElement->put_href(bstrHref);
				}
				delete psz;

				/*
                if (hr == S_OK && spdispImage != NULL)
                {
                    // ܂Aėp HTML vfC^[tFCXɏƉ܂...
                    CComQIPtr<IHTMLElement> spElement = spdispImage;
                    if (spElement)
                    {
                        // ...style C^[tFCX₢킹܂B
                        CComPtr<IHTMLStyle> spStyle;
                        hr = spElement->get_style(&spStyle);
                        // display="none" ݒ肵āA摜\ɂ܂B
                        if (hr == S_OK && spStyle != NULL)
                        {
                            static const CComBSTR sbstrNone(L"none");
                            spStyle->put_display(sbstrNone);
                        }
                    }
                }
				*/
            }
        }
	}
	}

// CHelloWorldBHO

